#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "funcions_eclipses.c"

const double PI=3.14159265;
const double MT=5.9742e24;
const double ML=7.3483e22;
const double MS=1.9891e30;

const double RS=696000.0;
const double RT=6378.140;
const double RTp=6356.755;
const double RL=1738.0;

int B=1;

int main(void) {

	int i, min=10, tipus=0;
	int any=2015, mes=3, dia=20;
	double longitud=2.15889, latitud=41.3889, Time, fin_e, inc=1.0/(24*60);
	double P[3], info[4], G;
	eclipse eclip;
	data dat;

	char ephem[30];
	strcpy(ephem,"ephem_1600_2200.405");
	
	if(B) {
		
		printf("Escriu l'any de l'eclipsi':\n");
		scanf("%d",&any);
		
		printf("Escriu el mes de l'eclipsi':\n");
		scanf("%d",&mes);
		
		printf("Escriu el dia de l'eclipsi':\n");
		scanf("%d",&dia);
		
		printf("Escriu la longitud geografica del lloc en graus':\n");
		scanf("%lf",&longitud);
		
		printf("Escriu la latitud geografica del lloc en graus':\n");
		scanf("%lf",&latitud);
		
		printf("Escriu el fitxer en binari utilitzat per obtenir les posicions:\n");
		scanf("%s",&ephem);
	}
	
	P[1]=longitud*PI/180;
	P[2]=latitud*PI/180;
	P[0]=RT*RTp/sqrt(pow(RTp*cos(P[2]),2)+pow(RT*sin(P[2]),2));
	
	Initialize_Ephemeris(ephem);
	
	eclip=eclip_lloc(any, mes, dia, P);
	if(eclip.n==0) {
		printf("No es veu l'eclipsi");
		return 0;
	}
	
	Time=eclip.temps[0];
	fin_e=eclip.temps[eclip.n];
	printf("\n\nAngles de visio:");
	printf("\n  Temps  # radi Sol # radi Lluna # centres Sol-Lluna # centre Lluna # grau enfos.");
	for(Time; Time<=fin_e; Time+=min*inc) {
		visio_eclipsi(Time, P, info, tipus);
		gdcon(Time,&dat);
		printf("\n%2d:%2d:%2d ",dat.hora,dat.min,(int)dat.seg);
		printf("# %f #  %f  #     %f      # %f ", info[0]*180/PI,info[1]*180/PI,info[2]*180/PI,info[3]*180/PI);
		G=info[1]-(info[2]-info[0]);
		if(G<0.0) {
			G=0.0;
		}
		else if(G>2*info[0]) {
			G=info[0];
		}
		if(info[0]>info[2]+info[1]) {
			G+=info[0]-info[2]+info[1];
		}
		G/=info[0];
		printf("#   %f",G);
	}
	printf("\n\nMaxim eclipsi");
	visio_eclipsi(eclip.max_eclip, P, info,tipus);
	gdcon(eclip.max_eclip,&dat);
	printf("\n%2d:%2d:%2d ",dat.hora,dat.min,(int)dat.seg);
	printf("# %f #  %f  #     %f      # %f ", info[0]*180/PI,info[1]*180/PI,info[2]*180/PI,info[3]*180/PI);
	G=info[1]-(info[2]-info[0]);
	if(G<0.0) {
		G=0.0;
	}
	else if(G>2*info[0]) {
		G=info[0];
	}
	if(info[0]>info[2]+info[1]) {
		G+=info[0]-info[2]+info[1];
	}
	G/=info[0];
	printf("#   %f",G);
	
	return 0;	
}
