#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "funcions_eclipses.c"

const double PI=3.14159265;
const double MT=5.9742e24;
const double ML=7.3483e22;
const double MS=1.9891e30;

const double RS=696000.0;
const double RT=6378.140;
const double RTp=6356.755;
const double RL=1738.0;

int B=1;

int main(void) {

	int i, any=2015, mes=3, dia=20;
	double longitud=2.15889, latitud=20.3889;
	double P[3], info[4];
	eclipse eclip;
	data dat;
	
	char ephem[30];
	strcpy(ephem,"ephem_1600_2200.405");
	
	if(B) {
		
		printf("Escriu l'any de l'eclipsi': ");
		scanf("%d",&any);
		
		printf("Escriu el mes de l'eclipsi': ");
		scanf("%d",&mes);
		
		printf("Escriu el dia de l'eclipsi': ");
		scanf("%d",&dia);
		
		printf("Escriu la longitud geografica del lloc en graus': ");
		scanf("%lf",&longitud);
		
		printf("Escriu la latitud geografica del lloc en graus': ");
		scanf("%lf",&latitud);
		
		printf("Escriu el fitxer en binari utilitzat per obtenir les posicions: ");
		scanf("%s",&ephem);
	}
	
	Initialize_Ephemeris(ephem);
	
	P[1]=longitud*PI/180;
	P[2]=latitud*PI/180;
	P[0]=RT*RTp/sqrt(pow(RTp*cos(latitud),2)+pow(RT*sin(latitud),2));
	eclip=eclip_lloc(any, mes, dia, P);
	if(eclip.n==0) {
		printf("No es veu l'eclipsi");
		return 0;
	}
	
	printf("\n\nParcial ");
	gdcon(eclip.temps[0],&dat);
	printf("# %2d/%2d/%4d %2d:%2d:%2d ",dat.dia,dat.mes,dat.any,dat.hora,dat.min,(int)dat.seg);
	gdcon(eclip.temps[eclip.n],&dat);
	printf("# %2d/%2d/%4d %2d:%2d:%2d\n",dat.dia,dat.mes,dat.any,dat.hora,dat.min,(int)dat.seg);
	for(i=1;i<(eclip.n-1);i++) {
		if(eclip.tipus[i]==2) {
			printf("Total ");
		}
		else {
			printf("Anular ");
		}
		gdcon(eclip.temps[i],&dat);
		printf("# %2d/%2d/%4d %2d:%2d:%2d ",dat.dia,dat.mes,dat.any,dat.hora,dat.min,(int)dat.seg);
		gdcon(eclip.temps[i+1],&dat);
		printf("# %2d/%2d/%4d %2d:%2d:%2d\n",dat.dia,dat.mes,dat.any,dat.hora,dat.min,(int)dat.seg);
	}
	visio_eclipsi(eclip.max_eclip, P, info, 0);
	gdcon(eclip.max_eclip,&dat);
	printf("Maxim eclipsi: %2d:%2d:%2d ",dat.hora,dat.min,(int)dat.seg);
	
	return 0;
}
