#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "rk4.c"
#include "funcions_posicio.c"
#include "temps.c"

const double PI=3.14159265;
const double RS=696000.0;

const double MT=5.9742e24;
const double ML=7.3483e22;
const double MS=1.9891e30;
const double MME=328.5e21;
const double MV=4.867e24;
const double MM=639e21;
const double MSA=568.3e24;
const double MU=86.81e24;
const double MN=102.4e24;
const double MP=1.25e22;
const double MJ=1.898e27;
double G=6.67384e-20*3600.0*3600.0*24.0*24.0;
const double UA=149597870.700;

const double I=23.43929111;

int pl=2; //planeta que volem observar el seu error

//extern double MT, ML, MS;

int main() {
	int i, j, k, c, fun, n=66, p=300, nh=24*60;
	double **Y, Time, aux, d_jpl, d2_jpl, d, d2, t, h=1.0/nh;
	double ang_RK4=0.0, ang_JPL=0.0;
	stateType P[11], JPL, JPL2;
	FILE *fe;
	
	G=G/pow(UA,3);
	
	if(pl==2) {
		c=10;
		fe=fopen("error_RK4_terra.txt","w");
	}
	else if(pl==0) {
		c=10;
		fe=fopen("error_RK4_mercuri.txt","w");
	}
	else if(pl==1) {
		c=10;
		fe=fopen("error_RK4_venus.txt","w");
	}
	else if(pl==3) {
		c=10;
		fe=fopen("error_RK4_mart.txt","w");
	}
	else if(pl==4) {
		c=10;
		fe=fopen("error_RK4_jupiter.txt","w");
	}
	else if(pl==9) {
		c=2;
		fe=fopen("error_RK4_lluna.txt","w");
	}
	
	Initialize_Ephemeris("ephem_1600_2200.405");
	
	Y=(double**)malloc((p+1)*sizeof(double));
	for(i=0;i<=p;i++) {
		Y[i]=(double*)malloc(n*sizeof(double));
	}
	
	t=clock();
	
	Time=Gregorian_to_Julian(2015,5,1,0,0,0.0);
	state_sist_solar(Time, P);
	
	for(k=0;k<n/6;k++) {
		for(i=0;i<3;i++) {
			Y[0][6*k+i]=P[k].Position[i]/UA;
			Y[0][6*k+i+3]=P[k].Velocity[i]*3600*24/UA;
		}
	}
	
	for(i=0;i<n/6;i++) {
		rotacio(&Y[0][i*6],-I*PI/180,1);
		rotacio(&Y[0][i*6+3],-I*PI/180,1);
	}
	
	RK4(n, Y, h, nh, p, 3);
	
	for(i=0;i<p;i++) {
		for(j=0;j<3;j++) {
			Y[i][6*pl+j]=Y[i][6*pl+j]-Y[i][6*c+j];
		}
	}
	
	for(k=0;k<3;k++) {
		JPL.Position[k]=(P[pl].Position[k]-P[c].Position[k])/UA;
		JPL.Velocity[k]=(P[pl].Velocity[k]-P[c].Velocity[k])*3600*24/UA;
	}
	rotacio(JPL.Position,-I*PI/180,1);
	rotacio(JPL.Velocity,-I*PI/180,1);
	
	for(j=1;j<p;j++) {
		Time=Time+h*nh;
		JPL2=JPL;
		state_sist_solar(Time, P);
		for(k=0;k<3;k++) {
			JPL.Position[k]=(P[pl].Position[k]-P[c].Position[k])/UA;
			JPL.Velocity[k]=(P[pl].Velocity[k]-P[c].Velocity[k])*3600*24/UA;
		}
		rotacio(JPL.Position,-I*PI/180,1);
		rotacio(JPL.Velocity,-I*PI/180,1);
		
		aux=Y[j-1][pl*6]*Y[j][pl*6]+Y[j-1][pl*6+1]*Y[j][pl*6+1];
		d=sqrt(pow(Y[j][pl*6],2)+pow(Y[j][pl*6+1],2));
		d2=sqrt(pow(Y[j-1][pl*6],2)+pow(Y[j-1][pl*6+1],2));
		ang_RK4=ang_RK4+acos(aux/(d*d2));
		aux=JPL2.Position[0]*JPL.Position[0]+JPL2.Position[1]*JPL.Position[1];
		d_jpl=sqrt(pow(JPL2.Position[0],2)+pow(JPL2.Position[1],2));
		d2_jpl=sqrt(pow(JPL.Position[0],2)+pow(JPL.Position[1],2));
		ang_JPL=ang_JPL+acos(aux/(d_jpl*d2_jpl));
		fprintf(fe,"%15.7e ",fabs(ang_RK4*180/PI-ang_JPL*180/PI));
		fprintf(fe,"%15.7e ",dist(&Y[j][pl*6],JPL.Position)/modul(JPL.Position));
		fprintf(fe,"\n");
	}
	
	t=clock()-t;
	printf("\nTemps exec: %.3f",(float)t/(CLOCKS_PER_SEC*60));
	
	for(i=0;i<p;i++) {
		free(Y[i]);
	}
	
	return 0;
}
