#include <stdio.h>
#include <string.h>
#include "funcions_eclipses.c"

const double PI=3.14159265;
const double MT=5.9742e24;
const double ML=7.3483e22;
const double MS=1.9891e30;
const double RS=696000.0;
const double RT=6378.140;
const double RTp=6356.755;
const double RL=1738.0;

double B=1;

//min: pas de temps pel eclipsi parcial
//min_tot_anu: pas de temps pel eclipsi total o anular
//n: nombre de punts de contacte en un instant

int main(void) {
	int any=2015, mes=3, dia=20, min=15, min_tot_anu=15, n=360, r, r2;
	int i, j, k, e=0, h=0, h2=-1;
	double S[3], L[3], T[3], t_eclip[2], Time, inc, fin_e, ang, aux=0.0;
	double eix[60][3], hor[60][3][3];
	char nom[30], nom2[30], ephem[30];
	strcpy(nom,"punts_ecl_20_3_2015.txt");
	strcpy(nom2,"punts_limit_ecl_20_3_2015.txt");
	strcpy(ephem,"ephem_1600_2200.405");
	FILE *fit, *fit2;
	eclipse eclip;
	data dat;
	
	if(B) {
		printf("Escriu l'any de l'eclipsi:\n");
		scanf("%d",&any);
		
		printf("Escriu el mes de l'eclipsi (1-12):\n");
		scanf("%d",&mes);
		if(mes<1||mes>12) {
			printf("Error a l'escriure el mes");
			return -1;
		}
		
		printf("Escriu el dia de l'eclipsi (1-31):\n");
		scanf("%d",&dia);
		if(mes<1||mes>31) {
			printf("Error a l'escriure el dia");
			return -1;
		}
		
		printf("Escriu el pas de temps en minuts pel con de penombra(1-60):\n");
		scanf("%d",&min);
		if(min<1||min>60) {
			printf("Error a l'escriure el pas de temps");
			return -1;
		}
		
		printf("Escriu el pas de temps en minuts pel con d'ombra(1-60):\n");
		scanf("%d",&min_tot_anu);
		if(min_tot_anu<1||min_tot_anu>60) {
			printf("Error a l'escriure el pas de temps");
			return -1;
		}
		
		printf("Escriu el nombre de punts per cada instant de temps:\n");
		scanf("%d",&n);
		if(n<1) {
			printf("Error a l'escriure el nombre de punts");
			return -1;
		}
		
		printf("Escriu el fitxer en binari utilitzat per obtenir les posicions: ");
		scanf("%s",&ephem);
		
		printf("Escriu el fitxer de sortida dels punts de contacte:\n");
		scanf("%s",&nom);
		
		printf("Escriu el fitxer de sortida de la resta de corbes:\n");
		scanf("%s",&nom2);
	}
	
	double punts[n+1][3];
	
	Initialize_Ephemeris(ephem);
	fit=fopen(nom,"w");
	fit2=fopen(nom2,"w");
	eclip=dades_eclipse_solar(any, mes, dia);
	if(eclip.n==0) {
		printf("\nNo hi ha eclipse");
		return 0;
	}
	fprintf(fit,"#longitud (deg) latitud (deg) hora (UTM)\n");
	fprintf(fit,"# Zona d'eclipse parcial\n");
	Time=(floor(eclip.temps[0]*24*60/min)+1.0)*(double)min/(24*60);	
	fin_e=eclip.temps[eclip.n];
	inc=(double)min/(24*60);
	for(Time; Time<fin_e; Time+=inc) {
		pos_STL(Time,S,T,L);
		gdcon(Time, &dat);
		r=punts_contacte(Time, n, punts, 0);
		r2=contacte_horitzo(Time, hor[h], 0);
		if(h2==-1&&r==n) {
			h2=h;
		}
		if(r<n&&r2==0) {
			fprintf(fit,"%f %f %f\n", hor[h][0][1]*180/PI, hor[h][0][2]*180/PI,(double)dat.hora+(double)dat.min/60+dat.seg/3600);
			aux=hor[h][0][1];
		}
		else {
			if(r>0) {
				aux=punts[0][2];
			}
		}
		ang=atan(T[1]/T[0]);
		if(T[0]>0.0) {
			ang=ang+PI;
		}
		for(j=0;j<r;j++) {
			for(k=0;k<3;k++) {
				punts[j][k]=punts[j][k]-T[k];
			}
			coord_ec_ge(punts[j],ang,Time);
			if(aux*punts[j][1]<0.0&&fabs(punts[j][1])>PI/2) {
				fprintf(fit,"\n");
				aux=punts[j][1];
			}
			fprintf(fit,"%f %f %f\n", punts[j][1]*180/PI, punts[j][2]*180/PI,(double)dat.hora+(double)dat.min/60+dat.seg/3600);
		}
		if(r<n&&r2==0) {
			if(aux*hor[h][1][1]<0.0&&fabs(hor[h][1][1])>PI/2) {
				fprintf(fit,"\n");
			}
			fprintf(fit,"%f %f %f\n", hor[h][1][1]*180/PI, hor[h][1][2]*180/PI,(double)dat.hora+(double)dat.min/60+dat.seg/3600);
			h++;
		}
		fprintf(fit,"\n");
	}
	
	if(eclip.n==2) {
		return 0;
	}
	
	fprintf(fit,"# Zona d'eclipse total o anular\n");
	Time=(floor(eclip.temps[1]*24*60/min)+1.0)*(double)min/(24*60);
	fin_e=eclip.temps[eclip.n-1];
	inc=(double)min_tot_anu/(24*60);
	for(Time; Time<fin_e; Time+=inc) {
		pos_STL(Time,S,T,L);
		gdcon(Time, &dat);
		r=punts_contacte(Time, n, punts, 1);
		if(r>0) {
			aux=punts[0][1];
		}
		for(j=0;j<r;j++) {
			for(k=0;k<3;k++) {
				punts[j][k]=punts[j][k]-T[k];
			}
			coord_ec_ge(punts[j],ang,Time);
			if(aux*punts[j][1]<0.0&&fabs(punts[j][1])>PI/2) {
				fprintf(fit,"\n");
				aux=punts[j][1];
			}
			fprintf(fit,"%f %f %f\n", punts[j][1]*180/PI, punts[j][2]*180/PI,(double)dat.hora+(double)dat.min/60+dat.seg/3600);
		}
		fprintf(fit,"\n");
		if(r>0&&(punts[n][0]!=0.0||punts[n][1]!=0.0)) {
			for(k=0;k<3;k++) {
				eix[e][k]=punts[n][k]-T[k];
			}
			coord_ec_ge(eix[e],ang,Time);
			e++;
		}
	}
	Time=fin_e;
	pos_STL(Time,S,T,L);
	gdcon(Time, &dat);
	r=punts_contacte(Time, n, punts, 1);
	if(r>0) {
		aux=punts[0][1];
	}
	for(j=0;j<r;j++) {
		for(k=0;k<3;k++) {
			punts[j][k]=punts[j][k]-T[k];
		}
		coord_ec_ge(punts[j],ang,Time);
		if(aux*punts[j][1]<0.0&&fabs(punts[j][1])>PI/2) {
			fprintf(fit,"\n");
			aux=punts[j][1];
		}
		fprintf(fit,"%f %f %f\n", punts[j][1]*180/PI, punts[j][2]*180/PI,(double)dat.hora+(double)dat.min/60+dat.seg/3600);
	}
	fprintf(fit,"\n");
	
	fprintf(fit2,"#longitud (deg) latitud (deg)\n");
	fprintf(fit2,"# Corba de l'eix d'ombra\n");
	if(e>0) {
		fprintf(fit2,"%f %f\n", eclip.punt_contacte[1][1]*180/PI, eclip.punt_contacte[1][2]*180/PI);
		aux=eclip.punt_contacte[1][1];
		for(i=0;i<e;i++) {
			if(aux*eix[i][1]<0.0&&fabs(eix[i][1])>PI/2) {
				fprintf(fit2,"\n");
				aux=eix[i][1];
			}
			fprintf(fit2,"%f %f\n", eix[i][1]*180/PI, eix[i][2]*180/PI);
		}
		if(aux*eclip.punt_contacte[eclip.n-1][1]<0.0&&fabs(eclip.punt_contacte[eclip.n][1])>PI/2) {
			fprintf(fit2,"\n");
		}
		fprintf(fit2,"%f %f\n", eclip.punt_contacte[eclip.n-1][1]*180/PI, eclip.punt_contacte[eclip.n-1][2]*180/PI);
		fprintf(fit2,"\n");
	}
	
	fprintf(fit2,"# Corba de punts de l'horitz al lmit de l'eclipsi\n");
	fprintf(fit2,"%f %f\n", eclip.punt_contacte[0][1]*180/PI, eclip.punt_contacte[0][2]*180/PI);
	aux=eclip.punt_contacte[0][1];
	for(i=0;i<h;i++) {
		if(i==h2) {
			fprintf(fit2,"%f %f\n", hor[i-1][2][1]*180/PI, hor[i-1][2][2]*180/PI);
			fprintf(fit2,"\n");
			fprintf(fit2,"%f %f\n", hor[i][2][1]*180/PI, hor[i][2][2]*180/PI);
			aux=hor[i][0][1]*180/PI;
		}
		if(aux*hor[i][0][1]<0.0&&fabs(hor[i][0][1])>PI/2) {
			fprintf(fit2,"\n");
			aux=hor[i][0][1]*180/PI;
		}
		fprintf(fit2,"%f %f\n", hor[i][0][1]*180/PI, hor[i][0][2]*180/PI);
	}
	if(aux*eclip.punt_contacte[eclip.n][1]<0.0&&fabs(eclip.punt_contacte[eclip.n][1])>PI/2) {
		fprintf(fit2,"\n");
	}
	fprintf(fit2,"%f %f\n", eclip.punt_contacte[eclip.n][1]*180/PI, eclip.punt_contacte[eclip.n][2]*180/PI);
	fprintf(fit2,"\n");
	
	fprintf(fit2,"# L'altre corba de punts de l'horitz al lmit de l'eclipsi\n");
	fprintf(fit2,"%f %f\n", eclip.punt_contacte[0][1]*180/PI, eclip.punt_contacte[0][2]*180/PI);
	aux=eclip.punt_contacte[0][1];
	for(i=0;i<h;i++) {
		if(i==h2) {
			fprintf(fit2,"%f %f\n", hor[i-1][2][1]*180/PI, hor[i-1][2][2]*180/PI);
			fprintf(fit2,"\n");
			fprintf(fit2,"%f %f\n", hor[i][2][1]*180/PI, hor[i][2][2]*180/PI);
			aux=hor[i][1][1]*180/PI;
		}
		if(aux*hor[i][1][1]*180/PI<0.0&&fabs(hor[i][1][1])>PI/2) {
			fprintf(fit2,"\n");
			aux=hor[i][1][1]*180/PI;
		}
		fprintf(fit2,"%f %f\n", hor[i][1][1]*180/PI, hor[i][1][2]*180/PI);
	}
	if(aux*eclip.punt_contacte[eclip.n][1]<0.0&&fabs(eclip.punt_contacte[eclip.n][1])>PI/2) {
		fprintf(fit2,"\n");
	}
	fprintf(fit2,"%f %f\n", eclip.punt_contacte[eclip.n][1]*180/PI, eclip.punt_contacte[eclip.n][2]*180/PI);
	fprintf(fit2,"\n");
	
	fprintf(fit2,"# Corba de mxim eclipsi\n");
	fprintf(fit2,"%f %f\n", eclip.punt_contacte[0][1]*180/PI, eclip.punt_contacte[0][2]*180/PI);
	aux=eclip.punt_contacte[0][1];
	for(i=0;i<h;i++) {
		if(i==h2) {
			fprintf(fit2,"\n");
			aux=hor[i][2][1]*180/PI;
		}
		if(aux*hor[i][2][1]*180/PI<0.0&&fabs(hor[i][2][1])>PI/2) {
			fprintf(fit2,"\n");
			aux=hor[i][2][1]*180/PI;
		}
		fprintf(fit2,"%f %f\n", hor[i][2][1]*180/PI, hor[i][2][2]*180/PI);
	}
	if(aux*eclip.punt_contacte[eclip.n][1]<0.0&&fabs(eclip.punt_contacte[eclip.n][1])>PI/2) {
		fprintf(fit2,"\n");
	}
	fprintf(fit2,"%f %f\n", eclip.punt_contacte[eclip.n][1]*180/PI, eclip.punt_contacte[eclip.n][2]*180/PI);
	fprintf(fit2,"\n");
	
	return 0;
}
