#include <stdio.h>
#include <math.h>
//#include "funcions_posicio.c"

extern const double MT, ML, MS, MME, MV, MM, MJ, MSA, MU, MN, MP;
extern double G;
int f, N;
double M[11];


// Origen el planeta de massa M[N]

void func0(double *Y, double *Z, double M[]) {
	int i, j, k, n=N;
	double d[n][n], T[3];
	
	for(i=0;i<n;i++) {
		for(j=0;j<3;j++) {
			Z[i*6+j]=Y[i*6+3+j];
		}
	}
	
	for(i=0; i<n; i++) {
		d[i][i]=pow(sqrt(pow(Y[i*6],2)+pow(Y[i*6+1],2)+pow(Y[i*6+2],2)),3);
		for(j=0; j<i; j++) {
			d[i][j]=pow(sqrt(pow(Y[i*6]-Y[j*6],2)+pow(Y[i*6+1]-Y[j*6+1],2)+pow(Y[i*6+2]-Y[j*6+2],2)),3);
		}
	}
	
	for(i=0;i<3;i++) {
		T[i]=0.0;
		for(j=0;j<n;j++) {
			T[i]+=-M[j]*Y[j*6+i]/d[j][j];
		}
	}
	
	for(i=0;i<3;i++) {
		for(j=0;j<n;j++) {
			Z[j*6+3+i]=T[i]-M[n]*Y[j*6+i]/d[j][j];
			for(k=0;k<j;k++) {
				Z[j*6+3+i]+=M[k]*(Y[k*6+i]-Y[j*6+i])/d[j][k];
				Z[k*6+3+i]+=M[j]*(Y[j*6+i]-Y[k*6+i])/d[j][k];
			}
		}
	}
	
	for(i=0;i<3;i++) {
		for(j=0;j<n;j++) {
			Z[j*6+3+i]*=M[n+1];
		}
	}
}

// Sistema de referencia inercial (origen BSS)

void func1(double *Y, double *Z, double M[]) {
	int i, j, k, n=N;
	double d[n][n];
	
	for(i=0;i<n;i++) {
		for(j=0;j<3;j++) {
			Z[i*6+j]=Y[i*6+3+j];
		}
	}
	
	for(i=0; i<n; i++) {
		for(j=0; j<i; j++) {
			d[i][j]=pow(sqrt(pow(Y[i*6]-Y[j*6],2)+pow(Y[i*6+1]-Y[j*6+1],2)+pow(Y[i*6+2]-Y[j*6+2],2)),3);
		}
	}
	
	for(i=0;i<3;i++) {
		for(j=0;j<n;j++) {
			Z[j*6+3+i]=0.0;
			for(k=0;k<j;k++) {
				Z[j*6+3+i]+=M[k]*(Y[k*6+i]-Y[j*6+i])/d[j][k];
				Z[k*6+3+i]+=M[j]*(Y[j*6+i]-Y[k*6+i])/d[j][k];
			}
		}
	}
	
	for(i=0;i<3;i++) {
		for(j=0;j<n;j++) {
			Z[j*6+3+i]*=M[n];
		}
	}
}

void func(double *Y, double *Z) {
	if(f==1) {
		M[0]=ML;
		M[1]=MT;
		M[2]=G;
		func0(Y,Z,M);
	}
	else if(f==2) {
		M[0]=ML;
		M[1]=MS;
		M[2]=MT;
		M[3]=G;
		func0(Y,Z,M);
	}
	else if(f==3) {
		M[0]=MME;
		M[1]=MV;
		M[2]=MT;
		M[3]=MM;
		M[4]=MJ;
		M[5]=MSA;
		M[6]=MU;
		M[7]=MN;
		M[8]=MP;
		M[9]=ML;
		M[10]=MS;
		M[11]=G;
		func1(Y,Z,M);
	}
}

//h: pas de temps, nh*h: pas de temps en que escriu el valor, p: nombre de valors escrits, fun: la funci utilitzada

void RK4(int n, double **Y, double h, int nh, int p, int fun) {
	int i, j;
	f=fun;
	N=n/6;
	double k[4][n], aux[n], aux2[n];
	
	for(j=0;j<n;j++) {
		aux[j]=Y[0][j];
	}
	
	for(i=1; i<=p*nh; i++) {
		func(aux,k[0]);
		
		for(j=0;j<n;j++) {
			aux2[j]=aux[j]+k[0][j]*h/2.0;
		}
		func(aux2,k[1]);
		
		for(j=0;j<n;j++) {
			aux2[j]=aux[j]+k[1][j]*h/2.0;
		}
		func(aux2,k[2]);
		
		for(j=0;j<n;j++) {
			aux2[j]=aux[j]+k[2][j]*h;
		}
		func(aux2,k[3]);
		
		for(j=0;j<n;j++) {
			aux[j]=aux[j]+(k[0][j]+2.0*(k[1][j]+k[2][j])+k[3][j])*h/6.0;
		}
		
		if(i%nh==0) {
			for(j=0;j<n;j++) {
				Y[i/nh][j]=aux[j];
			}
		}
	}
}
