#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "funcions_eclipses.c"

const double PI=3.14159265;
const double MT=5.9742e24;
const double ML=7.3483e22;
const double MS=1.9891e30;

const double RS=696000.0;
const double RT=6378.140;
const double RTp=6356.755;
const double RL=1738.0;

const double minST=147096146.258;

int B=1;

int main(void) {

	int i, any, mes, dia, t_ini, t_fin, n=360, tipus=0;
	double longitud=2.15889, latitud=41.3889, Time, unitat;
	double P[3], info[4], L[2], dSL, r, h;
	double ang1, ang2;
	eclipse eclip;
	data dat;
	char *nom1="visio_max_ecl", *nom2="visio_ini_ecl", *nom3="visio_fin_ecl";
	
	char ephem[30];
	strcpy(ephem,"ephem_1600_2200.405");
	
	if(B) {
		
		printf("Escriu l'any de l'eclipsi':\n");
		scanf("%d",&any);
		
		printf("Escriu el mes de l'eclipsi':\n");
		scanf("%d",&mes);
		
		printf("Escriu el dia de l'eclipsi':\n");
		scanf("%d",&dia);
		
		printf("Escriu la longitud geografica del lloc en graus':\n");
		scanf("%lf",&longitud);
		
		printf("Escriu la latitud geografica del lloc en graus':\n");
		scanf("%lf",&latitud);
		
		printf("Escriu el fitxer en binari utilitzat per obtenir les posicions:\n");
		scanf("%s",&ephem);
		
		
	}
	
	Initialize_Ephemeris(ephem);
	
	P[1]=longitud*PI/180;
	P[2]=latitud*PI/180;
	P[0]=RT*RTp/sqrt(pow(RTp*cos(latitud),2)+pow(RT*sin(latitud),2));
	eclip=eclip_lloc(any, mes, dia, P);
	if(eclip.n==0) {
		printf("No es veu l'eclipsi");
		return 0;
	}
	
	unitat=asin(RS/minST);

	visio_eclipsi(eclip.max_eclip, P, info, tipus);
	L[0]=cos(info[3])*info[2]/unitat;
	L[1]=sin(info[3])*info[2]/unitat;
	
	FILE *gnuplot = popen("gnuplot", "w");
	fprintf(gnuplot,"set terminal postscript color enhanced\n");
	fprintf(gnuplot,"set output '%s.eps'\n",nom1);
	fprintf(gnuplot,"unset key\n");
	fprintf(gnuplot,"set size ratio -1\n");
	fprintf(gnuplot, "plot '-' with lines\n");
	
	for(i=0;i<n;i++) {
		fprintf(gnuplot,"%f %f\n", L[0]+cos(2*PI*i/n)*info[1]/unitat, L[1]+sin(2*PI*i/n)*info[1]/unitat);
	}
	fprintf(gnuplot,"\n");
	r=(pow(info[2]/unitat,2)+pow(info[0]/unitat,2)-pow(info[1]/unitat,2))/(2*(info[2]/unitat));
	h=sqrt(pow(info[0]/unitat,2)-r*r);
	h=atan(h/r);
	if(h<0) {
		h+PI;
	}
	ang1=info[3]+h;
	ang2=info[3]-h+2*PI;
	
	while(ang1<=ang2) {
		fprintf(gnuplot,"%f %f\n", cos(ang1)*info[0]/unitat, sin(ang1)*info[0]/unitat);
		ang1+=2*PI/n;
	}
	fprintf(gnuplot, "e\n");
	
	visio_eclipsi(eclip.temps[0], P, info,tipus);
	L[0]=cos(info[3])*info[2]/unitat;
	L[1]=sin(info[3])*info[2]/unitat;
	
	fprintf(gnuplot,"set output '%s.eps'\n",nom2);
	fprintf(gnuplot,"unset key\n");
	fprintf(gnuplot,"set size ratio -1\n");
	fprintf(gnuplot, "plot '-' with lines\n");
	
	for(i=0;i<n;i++) {
		fprintf(gnuplot,"%f %f\n", L[0]+cos(2*PI*i/n)*info[1]/unitat, L[1]+sin(2*PI*i/n)*info[1]/unitat);
	}
	fprintf(gnuplot,"\n");
	for(i=0;i<n;i++) {
		fprintf(gnuplot,"%f %f\n", cos(2*PI*i/n)*info[0]/unitat, sin(2*PI*i/n)*info[0]/unitat);
	}
	fprintf(gnuplot, "e\n");
	
	visio_eclipsi(eclip.temps[eclip.n], P, info, tipus);
	L[0]=cos(info[3])*info[2]/unitat;
	L[1]=sin(info[3])*info[2]/unitat;
	
	fprintf(gnuplot,"set output '%s.eps'\n",nom3);
	fprintf(gnuplot,"unset key\n");
	fprintf(gnuplot,"set size ratio -1\n");
	fprintf(gnuplot, "plot '-' with lines\n");
	
	for(i=0;i<n;i++) {
		fprintf(gnuplot,"%f %f\n", L[0]+cos(2*PI*i/n)*info[1]/unitat, L[1]+sin(2*PI*i/n)*info[1]/unitat);
	}
	fprintf(gnuplot,"\n");
	for(i=0;i<n;i++) {
		fprintf(gnuplot,"%f %f\n", cos(2*PI*i/n)*info[0]/unitat, sin(2*PI*i/n)*info[0]/unitat);
	}
	fprintf(gnuplot, "e\n");
	
	fflush(gnuplot);
	fprintf(gnuplot, "exit \n");
	pclose(gnuplot);
	
	return 0;	
}
